//Private
//var _events = [];
//var exporterDvdStl = require("./ExporterDvdStl.js");

function Exporter(filepath, data) {
	console.log("ExporterDvdAdobe: Exporter: called with filepath=["+filepath+"]");
	var fs = require('fs');
	var wstream = fs.createWriteStream(filepath, {encoding: "utf8"});
	writeFileAdobe(wstream,data)
	wstream.end();
}

function writeFileAdobe(strm, o){
	//http://www.adobepress.com/articles/article.asp?p=600973&seqNum=4
	//the subtitle numbers are 1-based; leave a blank line between captions
	//1 00;00;00;00 00;00;15;10 A single line caption.
	
	//2 00;00;15;11 00;00;17;12 This is and
	//multi-line caption.


	//no headers
	
	var sfoo = "";
	for( var i=0; i<o.events.length; i++ ){
		//console.log(JSON.stringify(o.events[i],null,5));
		thetext = eventToAdobe(o.events[i]);
		strm.write((i+1).toString() + ' ' + o.events[i].intime.toTimecodeSMPTEallColons() + ' ' + o.events[i].outtime.toTimecodeSMPTEallColons() + ' ' + thetext +'\n');
		strm.write('\n');
	}
	strm.write('\n');
}//writeFileSRT
function eventToAdobe(e){
	var sfoo="", ret="", tr={}, bgottext = false;
	//log.debug("eventToVTT: textRuns=["+JSON.stringify(e.textRuns, null, 2)+"]");
	for( var i=0; i<e.textRuns.length; i++ ){
		//if( i==0 ) sfoo = "";
		tr=e.textRuns[i];
		sfoo = tr.text;
		
		if( sfoo.trim().length > 0 )
			bgottext = true;
		//log.debug("eventToVTT: tr.id=["+tr.id+"] bgotext=["+bgottext+"]");
		
		if( tr.linebreak ){
			if( bgottext ){	//linebreak and already found text
				//log.debug("eventToVTT: tr.id=["+tr.id+"] linebreak=true, bgottext=true");
				ret += "\n";
				bgottext = false;
				continue;
			} else {		//linebreak and no text yet
				//log.debug("eventToVTT: tr.id=["+tr.id+"] linebreak=true, bgottext=false");
				continue;
			}
		} else {
		}
		
		//log.debug("eventToSRT: run sfoo=["+sfoo+"] len=["+sfoo.length+"] endval=["+sfoo.charCodeAt(1)+"]");
		//if( sfoo.length==0 ) sfoo = " ";//"\u200B";//use zero-width space instead of a space// =" ";
		if( i==e.textRuns.length-1 ) sfoo = sfoo.replace(/\s+$/, ''); //sfoo = sfoo.trim(); //trim the last space
		
		ret += sfoo;
		//log.debug("eventToSRT: normal ret now=["+ret+"]");
		
	}//textRuns
	
	//log.debug("eventToSRT: finally return ret=["+ret+"] len=["+ret.length+"]");
	return ret;

}//eventToSRT


//Public
module.exports = Exporter;
